const lint_size=38;
type lint=array [1..lint_size] of integer;
procedure ladd(var a,b,c:lint);
var i,p:integer;
begin
  p:=0;
  for i:=1 to lint_size do
  begin
    p:=p+a[i]+b[i];
    if p>=10000 then
    begin
      c[i]:=p - 10000;
      p:=1;
    end
    else
    begin
      c[i]:=p;
      p:=0;
    end
  end;
end;
procedure lset(v:integer; var a:lint);
var i:integer;
begin
  a[1]:=v;
  for i:=2 to lint_size do
    a[i]:=0;
end;
procedure lprint(var a:lint);
var i:integer;
begin
  i:=lint_size;
  while (i>1) and (a[i]=0) do
    dec(i);
  write(a[i]);
  while i>1 do
  begin
    dec(i);
    write(a[i] div 1000, a[i] div 100 mod 10, a[i] div 10 mod 10, a[i] mod 10);
  end;
end;
type plint=^lint;
var a1,a2:array[0..1023] of plint;
    r:lint;
    i,j,k,n,m,kv,kv1,t:integer;
function checkv(a:integer):boolean;
var i,m:integer;
begin
  for i:=0 to n-3 do
  begin
    m:=((a shr i) and 7);
    if (m=7) or (m=0) then
    begin
      checkv:=false;
      exit;
    end;
  end;
  checkv:=true;
end;
begin
  read(n,m);
  for i:=0 to 1023 do
  begin
    new(a1[i]);
    new(a2[i]);
  end;
  if m<=2 then
  begin
    k:=n;
    n:=m;
    m:=k;
  end;
  if (n<=2) and (m<=2) then
  begin
    writeln(1 shl (n*m));
    halt(0);
  end;
  kv:=(1 shl (2*n))-1;
  kv1:=(1 shl n)-1;
  for i:=0 to kv do
  begin
    if checkv(i) and checkv(i shr n) then
      lset(1,a1[i]^)
    else
      lset(0,a1[i]^);
  end;
  for k:=3 to m do
  begin
    for i:=0 to kv do
      lset(0,a2[i]^);
    for i:=0 to kv1 do
    begin
      if checkv(i) then
      begin
        for j:=0 to kv do
        begin
          if ((i and j and (j shr n))=0) and 
             (((not i) and (not j) and (not (j shr n)) and ((1 shl n)-1))=0) then
          begin
            t:=(j shr n) or (i shl n);
            ladd(a1[j]^,a2[t]^,a2[t]^);
          end;
        end;
      end;
    end;
    for i:=0 to kv do
      a1[i]^:=a2[i]^;
  end;
  lset(0,r);
  for i:=0 to kv do
    ladd(a1[i]^,r,r);
  lprint(r);
  writeln;
end.
